import { NextApiRequest, NextApiResponse } from 'next';

declare type SCHEMA_TYPE = 'Yup' | 'FastestValidator' | 'Joi' | 'Zod' | 'SuperStruct' | 'Vest' | 'ClassValidator' | 'IoTS' | 'Nope';

declare type NextHandler = (err?: Error) => void;
declare type ValidationHoF = {
    type: SCHEMA_TYPE;
    mode?: 'body' | 'query' | 'headers';
    schema: unknown;
};
declare function withValidation({ type, schema, mode, }: ValidationHoF): (handler?: ((req: NextApiRequest, res: NextApiResponse<any>) => any) | undefined) => (req: NextApiRequest, res: NextApiResponse, next?: NextHandler) => Promise<any>;

export { withValidation };
